/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 03/11/2017
 --------------------------------------------------------
*/
package com.portofolio.entity;

import static com.portofolio.base.adapter.DatabaseAdapter.Constant.AKHIR_KURUNG;
import static com.portofolio.base.adapter.DatabaseAdapter.Constant.AWAL_KURUNG;
import static com.portofolio.base.adapter.DatabaseAdapter.Constant.INTEGER;
import static com.portofolio.base.adapter.DatabaseAdapter.Constant.VARCHAR;

import java.util.Set;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.Id;
import javax.persistence.Index;
import javax.persistence.JoinColumn;
import javax.persistence.JoinColumns;
import javax.persistence.ManyToOne;
import javax.persistence.OneToMany;
import javax.persistence.Table;
import javax.persistence.Version;
import javax.validation.constraints.NotNull;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;

import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import org.hibernate.annotations.Type;

import lombok.Setter;


@Entity
@Table(name = "ObjekModulAplikasi_S",indexes = {@Index(name = "ObjekModulAplikasi_S_Index",  columnList="statusEnabled", unique = false) })
@Getter
@Setter
@AllArgsConstructor
@NoArgsConstructor
@JsonIgnoreProperties({ "hibernateLazyInitializer", "handler" })
public class ObjekModulAplikasi {
    
    private static final String cDefKdObjekModulAplikasi = VARCHAR + AWAL_KURUNG + 6 + AKHIR_KURUNG ;
    @Id
    @Column(name = "KdObjekModulAplikasi",   columnDefinition = cDefKdObjekModulAplikasi)
    @NotNull(message = "objekmodulaplikasiid.kdobjekmodulaplikasi.notnull")
    private String kode;
    
    private static final String cDefObjekModulAplikasi = VARCHAR + AWAL_KURUNG + 200 + AKHIR_KURUNG ;
    @Column(name = "ObjekModulAplikasi", columnDefinition = cDefObjekModulAplikasi)
    @NotNull(message = "objekmodulaplikasi.objekmodulaplikasi.notnull")
    private String namaObjekModulAplikasi;
    
    private static final String cDefReportDisplay = VARCHAR + AWAL_KURUNG + 200 + AKHIR_KURUNG ;
    @Column(name = "ReportDisplay", columnDefinition = cDefReportDisplay)
    @NotNull(message = "objekmodulaplikasi.reportdisplay.notnull")
    private String reportDisplay;
    
    private static final String cDefDeskripsiObjek = VARCHAR + AWAL_KURUNG + 500 + AKHIR_KURUNG ;
    @Column(name = "DeskripsiObjek", columnDefinition = cDefDeskripsiObjek)
    private String deskripsiObjek;
    
    private static final String cDefFungsiObjek = VARCHAR + AWAL_KURUNG + 500 + AKHIR_KURUNG ;
    @Column(name = "FungsiObjek", columnDefinition = cDefFungsiObjek)
    private String fungsiObjek;
    
    private static final String cDefKdTypeDataObjek =INTEGER;
    @Column(name = "KdTypeDataObjek", columnDefinition = cDefKdTypeDataObjek)
    private Integer kdTypeDataObjek;
    
    private static final String cDefLengthObjek =INTEGER;
    @Column(name = "LengthObjek", columnDefinition = cDefLengthObjek)
    private Integer lengthObjek;
    
    private static final String cDefPrecisionObjek =INTEGER;
    @Column(name = "PrecisionObjek", columnDefinition = cDefPrecisionObjek)
    private Integer precisionObjek;
    
    private static final String cDefisObjekPK =INTEGER;
    @Column(name = "isObjekPK", columnDefinition = cDefisObjekPK)
    private Integer isObjekPK;
    
    private static final String cDefisObjekFK =INTEGER;
    @Column(name = "isObjekFK", columnDefinition = cDefisObjekFK)
    private Integer isObjekFK;
    
    private static final String cDefisObjekFKPK =INTEGER;
    @Column(name = "isObjekFKPK", columnDefinition = cDefisObjekFKPK)
    private Integer isObjekFKPK;
    
    private static final String cDefisObjekNullable =INTEGER;
    @Column(name = "isObjekNullable", columnDefinition = cDefisObjekNullable)
    private Integer isObjekNullable;
    
    private static final String cDefCthDataObjek = VARCHAR + AWAL_KURUNG + 300 + AKHIR_KURUNG ;
    @Column(name = "CthDataObjek", columnDefinition = cDefCthDataObjek)
    private String cthDataObjek;
    
    private static final String cDefKdObjekModulAplikasiHead = VARCHAR + AWAL_KURUNG + 6 + AKHIR_KURUNG ;
    @Column(name = "KdObjekModulAplikasiHead", columnDefinition = cDefKdObjekModulAplikasiHead)
    private String kdObjekModulAplikasiHead;
    
    private static final String cDefAlamatURLFormObjek = VARCHAR + AWAL_KURUNG + 500 + AKHIR_KURUNG ;
    @Column(name = "AlamatURLFormObjek", columnDefinition = cDefAlamatURLFormObjek)
    private String alamatURLFormObjek;
    
    private static final String cDefKdKelompokTransaksi =INTEGER;
    @Column(name = "KdKelompokTransaksi", columnDefinition = cDefKdKelompokTransaksi)
    private Integer kdKelompokTransaksi;
    
    private static final String cDefNoUrutObjek =INTEGER;
    @Column(name = "NoUrutObjek", columnDefinition = cDefNoUrutObjek)
    private Integer noUrutObjek;
    
    private static final String cDefIsMenu =INTEGER;
    @Column(name = "isMenu", columnDefinition = cDefIsMenu)
    private Integer isMenu;    

    private static final String cDefStatusEnabled =INTEGER;
    @Column(name = "StatusEnabled", columnDefinition = cDefStatusEnabled)
    @NotNull(message = "objekmodulaplikasi.statusenabled.notnull")
    @Type(type = "org.hibernate.type.NumericBooleanType") private Boolean statusEnabled;
    
    private static final String cDefNoRec = VARCHAR + AWAL_KURUNG + 36 + AKHIR_KURUNG ;
    @Column(name = "NoRec", columnDefinition = cDefNoRec)
    @NotNull(message = "objekmodulaplikasi.norec.notnull")
    private String noRec;
    
    private static final String cDefVersion =INTEGER;
    @Version
    @Column(name = "version", nullable = false,  columnDefinition = cDefVersion)
    @NotNull(message = "objekmodulaplikasi.version.notnull")
    private Integer version;
    
    
    @OneToMany(fetch= FetchType.LAZY)
    @JsonIgnore
    @JoinColumns({
        @JoinColumn(name="KdObjekModulAplikasi", referencedColumnName="KdObjekModulAplikasi",insertable=false, updatable=false),
    })
    // @ForeignKey(name="none")
    Set<MapObjekModulToKelompokUser> mapObjekModulToKelompokUser;
    
    @OneToMany(fetch= FetchType.LAZY)
    @JsonIgnore
    @JoinColumns({
        @JoinColumn(name="KdObjekModulAplikasi", referencedColumnName="KdObjekModulAplikasi",insertable=false, updatable=false),
    })
    // @ForeignKey(name="none")
    Set<MapObjekModulToModulAplikasi> mapObjekModulToModulAplikasi;
    
    @OneToMany(fetch= FetchType.LAZY)
    @JsonIgnore
    @JoinColumns({
        @JoinColumn(name="KdObjekModulAplikasi", referencedColumnName="KdObjekModulAplikasi",insertable=false, updatable=false),
    })
    Set<MapModulAplikasiToObjekModul> mapModulAplikasiToObjekModul;

}
